// Capture.cpp : implementation file
//

#include "stdafx.h"
#include "DataMan.h"
#include "Capture.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCapture
//
// ׽(汾1.0)
//
// ɹ: ò׽,ɲ׽
//
// 汾: 
//
/////////////////////////////////////////////////////////////////////////////

BOOL CCapture::m_bDrvUsed = FALSE;//豸Ƿʹ
CCapture * CCapture::m_pStaticCap = NULL;//ָ̬

//дļص
LRESULT CALLBACK CCapture::CallbackWriteToFile(HWND hWnd,LPVIDEOHDR lpVHdr);
//״̬ص
LRESULT CALLBACK CCapture::CallbackStatus(HWND hWnd, int nID,LPSTR lpStatusText);
//ص
LRESULT CALLBACK CCapture::CallbackError(HWND hWnd, int nErrID,LPSTR lpErrorText);
//ƻص
LRESULT CALLBACK CCapture::CallbackControl(HWND hWnd, int nState);
//CFile * pDataFile;


//////////////////////////////////////////////////////////////////
//
// CCapture()
// ĬϹ캯,޸,ԼĴڱ
//
//////////////////////////////////////////////////////////////////

//ĬϹ캯,޸,ԼĴڱ
CCapture::CCapture()
{
	m_nWindowHided = 0;
	m_nDeviceCount = 0;
	m_strCapTitle = _T("׽ Capture Window "); // window name if pop-up 
	m_CapRect.SetRect(0 , 0 , 0 , 0);
	m_CapWndStyle = WS_VISIBLE,       // window style 
	m_hwndParent = NULL;
	m_nID = 0;
	m_nCapRate = 15 ; //֡
//	m_pfileCapData = NULL;
//	m_fileCapDataName = "C:\\cap.dat";
	GetDeviceInfo();
}


//////////////////////////////////////////////////////////////////
//
// CCapture(CRect rect , HWND hwnd , CString title , int id)
// 캯,
//
// rect Ϊ׽ڳʼС,ʵʲ׽Сɲ׽þ
// hwnd ׽ڵĸھ
// title ׽ڵı
// id ׽ڵıʶ
//
//////////////////////////////////////////////////////////////////

//캯
CCapture::CCapture(CRect rect , HWND hwnd , CString title , int id)
{
	m_nWindowHided = 0;
	m_nDeviceCount = 0;
	m_strCapTitle = title; //ڱ
	m_CapRect = rect;//ڴС
	m_CapWndStyle = WS_VISIBLE,       // window style 
	m_hwndParent = hwnd ;//
	if (m_hwndParent != NULL)
		m_CapWndStyle |= WS_CHILD;
	m_nID = id;
	m_nCapRate = 15 ; //֡
//	m_pfileCapData = NULL;
//	m_fileCapDataName = "C:\\cap.dat";
	GetDeviceInfo();
}

//////////////////////////////////////////////////////////////////
// 
// ~CCapture()
// 
//
//////////////////////////////////////////////////////////////////

//
CCapture::~CCapture()
{
	Quit();
//	delete	m_pfileCapData;
}


BEGIN_MESSAGE_MAP(CCapture, CWnd)
	//{{AFX_MSG_MAP(CCapture)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCapture message handlers

//////////////////////////////////////////////////////////////////
// 
// GetDeviceCount()
//
// ɹ:
//     õ豸
//
// :
//     
//
// ز:
//	   豸
//
//////////////////////////////////////////////////////////////////

//õ豸
int CCapture::GetDeviceCount()
{
//	GetDeviceInfo();
	return m_nDeviceCount;
}


//////////////////////////////////////////////////////////////////
// 
// Init(int no)
// 
// ɹ:
//     ʼ豸׽
//
// :
//     豸no
//
// ز:
//	   ʼǷɹ
//
//////////////////////////////////////////////////////////////////

//ʼ豸׽
BOOL CCapture::Init(int no)
{
	//豸ʹ
	if (m_bDrvUsed == TRUE)
	{
		int ret = AfxMessageBox(_T("豸ʹãǷϿ\nDevice is using,disconnect it or not?\n"),MB_YESNO);
		if (ret == IDYES)
		{
			//ر
			DisconnectDriver();
			//ٴ
			::DestroyWindow(m_hCapWnd);
		}
		else
			return TRUE;
	}

	//׽
	m_hCapWnd = capCreateCaptureWindow (
		m_strCapTitle,//ڱ
		m_CapWndStyle,//ڷ
		m_CapRect.left, m_CapRect.top, //ڴСλ
		m_CapRect.right, m_CapRect.bottom, // window position and dimensions
		m_hwndParent, //
		m_nID /* child ID */);//ʶ 

	if (m_hCapWnd != NULL)
	{
		//ڴɹ
		//豸
		BOOL fOK = ConnectDriver(no);
		
		if (fOK != NULL)
		{
			//ӳɹ
			m_bDrvUsed = TRUE;
				
			CAPSTATUS Status;
			//ȡ״̬
			GetCapStatus(&Status);

			//ôλ
			SetWindowPos(HWND_TOPMOST, 0, 0,
				Status.uiImageWidth, 
				Status.uiImageHeight,
				//SWP_NOZORDER | SWP_NOMOVE);
				SWP_SHOWWINDOW);

			//״̬ص
			SetStatusCallback();
			//ôص
			SetErrorCallback();
			//ÿƻص
			SetControlCallback();

			return TRUE;
		}
	}
#ifdef _DEBUG
	TRACE("Can not Conncet driver ! Init fail!\n");
#endif

	::DestroyWindow(m_hCapWnd);
	AfxMessageBox(_T("ܴƵ\nCan't create capture window"));

	return FALSE;
}


//////////////////////////////////////////////////////////////////
// 
// GetDeviceInfo()
// 
// ɹ:
//     õ豸Ϣ,ö豸,õ豸
//
// :
//     
//
// ز:
//	   
//
//////////////////////////////////////////////////////////////////

//õ豸Ϣ
void CCapture::GetDeviceInfo()
{
	char szDeviceName[80];
	char szDeviceVersion[80];

	int wIndex;
	
	m_nDeviceCount = 0;

	for (wIndex = 0; wIndex < 10; wIndex++) 
	{
		//ö豸0--9
		if (capGetDriverDescription (wIndex, szDeviceName, 
			sizeof (szDeviceName), szDeviceVersion, 
			sizeof (szDeviceVersion)))
		{
			//豸
			m_nDeviceCount ++;
			//豸
			m_strDeviceName.Add(szDeviceName);
			//汾
			m_strDeviceVersion.Add(szDeviceVersion);

#ifdef _DEBUG
			TRACE("Name :%s \n",m_strDeviceName[wIndex]);
			TRACE("Version :%s \n",m_strDeviceVersion[wIndex]);
#endif
		}
	} 
}


//////////////////////////////////////////////////////////////////
// 
// GetDrvCap(CAPDRIVERCAPS * pCap)
// 
// ɹ:
//     õ豸
//
// :
//     豸ṹָ pCap
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//õ豸
BOOL CCapture::GetDrvCap(CAPDRIVERCAPS * pCap)
{
	if (pCap == NULL)
		return false;

	BOOL ret = capDriverGetCaps(m_hCapWnd, pCap, sizeof (CAPDRIVERCAPS));
#ifdef _DEBUG
	//豸
	TRACE("Diver index is : %d \n",pCap->wDeviceIndex);
	
	//Ƿָ֧ǹ
	if (pCap->fHasOverlay == TRUE)
		TRACE("Support Video-overlay.\n");
	else
		TRACE("Not Support Video-overlay.\n");

	//Ƿ֧ƵԴԻ
	if (pCap->fHasDlgVideoSource == TRUE)
		TRACE("Support Video source dialog.\n");
	else
		TRACE("Not Support Video source dialog.\n");
	
	//Ƿ֧ƵʽԻ
	if (pCap->fHasDlgVideoFormat == TRUE)
		TRACE("Support Video format dialog.\n");
	else
		TRACE("Not Support Video format dialog.\n");

	//Ƿ֧ƵʾԻ
	if (pCap->fHasDlgVideoDisplay == TRUE)
		TRACE("Support redisplay of video from the capture frame buffer.\n");
	else
		TRACE("Not Support redisplay of video from the capture frame buffer.\n");
	
	//豸ʼǷɹ
	if (pCap->fCaptureInitialized == TRUE)
		TRACE("The capture device has been successfully connected\n");
	else
		TRACE("The capture device has not been successfully connected");

	//豸Ƿֵ֧ɫ
	if(pCap->fDriverSuppliesPalettes == TRUE)
		TRACE("The driver can create palettes. \n");
	else
		TRACE("The driver can not create palettes. \n");
#endif

	return ret;
}


//////////////////////////////////////////////////////////////////
// 
// OpenPreview()
// 
// ɹ:
//     Ԥʽ
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ԥʽ
BOOL CCapture::OpenPreview()
{
	//رո
	DisableOverlay();
	m_bOverLay = false;

	BOOL ret = FALSE;
	//Ԥ֡
	ret = capPreviewRate(m_hCapWnd, (1.0e3 / m_nCapRate));    
	if (ret != FALSE) 
	{
		//ʼԤ
		ret = capPreview(m_hCapWnd, TRUE);       // starts preview 
	}

#ifdef _DEBUG
	if ( ret == FALSE)
		TRACE("Can not preview!\n");
	else
		TRACE("Open preview!\n");
#endif

	return ret;
}


//////////////////////////////////////////////////////////////////
// 
// ClosePreview()
// 
// ɹ:
//     رԤʽ
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//رԤʽ
BOOL CCapture::ClosePreview()
{
#ifdef _DEBUG
	TRACE("Close Preview!\n");
#endif

	//رԤ
	return capPreview(m_hCapWnd, FALSE);        // disables preview 
}


//////////////////////////////////////////////////////////////////
// 
// ConnectDriver(int no)
// 
// ɹ:
//     Ƶ׽
//
// :
//     豸no
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶ׽
BOOL CCapture::ConnectDriver(int no)
{
	if (no < 0)
		return false;

#ifdef _DEBUG
	TRACE("Connect Driver!\n");
#endif
	
	//豸
	return capDriverConnect(m_hCapWnd, no);
}


//////////////////////////////////////////////////////////////////
// 
// DisconnectDriver()
// 
// ɹ:
//     ϿƵ׽
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ϿƵ׽
BOOL CCapture::DisconnectDriver()
{
#ifdef _DEBUG
	TRACE("Disconnect Driver!\n");
#endif

	//Ͽ豸
	return capDriverDisconnect(m_hCapWnd); 
}


//////////////////////////////////////////////////////////////////
// 
// GetCapStatus(CAPSTATUS * pStatus)
// 
// ɹ:
//     õ豸״̬
//
// :
//     豸״̬ṹָ pStatus
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//õ豸״̬
BOOL CCapture::GetCapStatus(CAPSTATUS * pStatus)
{
	if( pStatus == NULL)
		return false;

	BOOL ret;

	//õ豸״̬
	ret = capGetStatus(m_hCapWnd, pStatus, sizeof (CAPSTATUS)); 

#ifdef _DEBUG

	//ͼ
	TRACE("Image width (in pixels) is %u .\n",pStatus->uiImageWidth);
	
	//ͼ߶
	TRACE("Image height (in pixels) is %u .\n",pStatus->uiImageHeight);
	
	//ǷʹԤ
	if (pStatus->fLiveWindow == TRUE)
		TRACE("The window is displaying video using the preview method.\n");
	else
		TRACE("The window is not using the preview method.\n");
	
	//Ƿʹø
	if (pStatus->fOverlayWindow == TRUE)
		TRACE("The window is displaying video using hardware overlay.\n");
	else
		TRACE("The window is not using hardware overlay.\n");
	
	//Ƿʹ췽ʽ
	if (pStatus->fScale == TRUE)
		TRACE("The window is scaling the input video to the client area when displaying video using preview. This parameter has no effect when displaying video using overlay.\n");
	else
		TRACE("The window is not scaling the input video to the client area when displaying video using preview. This parameter has no effect when displaying video using overlay.\n");
	
	//Ͻ
	TRACE("The upper left corner is (%d , %d).\n", pStatus->ptScroll.x,pStatus->ptScroll.y);
	
	//ǷʹĬϵɫ
	if (pStatus->fUsingDefaultPalette == TRUE)
		TRACE("The capture driver is using its default palette.\n");
	else
		TRACE("The capture driver is not using its default palette.\n");
	
	//ǷװƵӲ
	if(pStatus->fAudioHardware == TRUE)
		TRACE("The system has waveform-audio hardware installed. \n");
	else
		TRACE("The system has not waveform-audio hardware installed. \n");
	
	//Ƿɲ׽ļ
	if (pStatus->fCapFileExists == TRUE)
		TRACE("A valid capture file has been generated.\n");
	else
		TRACE("A valid capture file has not been generated yet.\n");
	
	//һβ׽֡
	TRACE("The number of frames processed during the current (or most recent) streaming capture is %d. (This count includes dropped frames.)\n", pStatus->dwCurrentVideoFrame); 

	//һβ׽֡
	TRACE("The number of frames dropped during the current (or most recent) streaming capture is %d. Dropped frames occur when the capture rate exceeds the rate at which frames can be saved to file. In this case, the capture driver has no buffers available for storing data is %d. (Dropping frames does not affect synchronization because the previous frame is displayed in place of the dropped frame.)\n",pStatus->dwCurrentVideoFramesDropped); 

	//һβ׽֡
	TRACE("The number of waveform-audio samples processed during the current (or most recent) streaming capture is %d.\n",pStatus->dwCurrentWaveSamples); 

	//ϴβ׽ʱ
	TRACE("The time ( in milliseconds ), since the start of the current (or most recent) streaming capture is %d.\n",pStatus->dwCurrentTimeElapsedMS); 

	//ڵɫľ
	TRACE("The Handle of current palette is %x.\n" ,pStatus->hPalCurrent);

	//Ƿڲ׽
	if ( pStatus->fCapturingNow == TRUE )
		TRACE("Capturing is in progress.\n");
	else
		TRACE("Not Capturing.\n");

	//صĴ
	TRACE("Error return values is %u.\n", pStatus->dwReturn); 

	//ƵС
	TRACE("Number of video buffers allocated is %u.\n",pStatus->wNumVideoAllocated);

	//ƵС
	TRACE("Number of audio buffers allocated is %u.\n",pStatus->wNumAudioAllocated);

#endif

	return ret;
}


//////////////////////////////////////////////////////////////////
// 
// DlgSetVideoSource()
// 
// ɹ:
//     ƵԴԻ
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ƵԴԻ
BOOL CCapture::DlgSetVideoSource()
{
	CAPDRIVERCAPS CapDrvCaps; 

	if (GetDrvCap(&CapDrvCaps) == FALSE) return FALSE;

	// Video source dialog box. 
	//Ƿ֧
	if (CapDrvCaps.fHasDlgVideoSource)
	{
		//֧

		//ز׽
		HideWindow();

		//ƵԴԻ
		capDlgVideoSource(m_hCapWnd); 

		//ʾ
		ShowWindow();
		return TRUE;
	}
	else
		return FALSE;
}


//////////////////////////////////////////////////////////////////
// 
// DlgSetVideoFormat()
// 
// ɹ:
//     ƵʽԻ
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ƵʽԻ
BOOL CCapture::DlgSetVideoFormat()
{
	CAPDRIVERCAPS CapDrvCaps; 

	if (GetDrvCap(&CapDrvCaps) == FALSE) return FALSE; 

	// Video format dialog box. 
	//Ƿ֧
	if (CapDrvCaps.fHasDlgVideoFormat) 
	{
		//֧

		//ز׽
		HideWindow();

		//ƵʽԻ
		capDlgVideoFormat(m_hCapWnd); 

		// Are there new image dimensions?
		//ǷıͼС
		CAPSTATUS Status;
		GetCapStatus(&Status);

		// If so, notify the parent of a size change.
		//ı䴰ڴС
		::SetWindowPos(m_hCapWnd, NULL, 0, 0,
			Status.uiImageWidth, 
			Status.uiImageHeight,
			SWP_NOZORDER | SWP_NOMOVE);		
		
		//ʾ
		ShowWindow();

		return TRUE;
	}
	else
		return FALSE;
}


//////////////////////////////////////////////////////////////////
// 
// DlgSetVideoDisplay()
// 
// ɹ:
//     ƵʾԻ
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ƵʾԻ
BOOL CCapture::DlgSetVideoDisplay()
{
	CAPDRIVERCAPS CapDrvCaps; 

	if (GetDrvCap(&CapDrvCaps) == FALSE) 
		return FALSE;

	// Video display dialog box. 
	//Ƿ֧
	if (CapDrvCaps.fHasDlgVideoDisplay)
	{
		//֧

		//ش
		HideWindow();

		//ƵʾԻ
		capDlgVideoDisplay(m_hCapWnd); 

		//ʾ
		ShowWindow();

		return TRUE;
	}
	else
		return FALSE;
}


//////////////////////////////////////////////////////////////////
// 
// DlgSetVideoCompression()
// 
// ɹ:
//     ƵѹԻ
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ƵѹԻ
BOOL CCapture::DlgSetVideoCompression()
{
	BOOL ret;

	//ش
	HideWindow();

	//ƵѹԻ
	ret = capDlgVideoCompression(m_hCapWnd); 

	//ʾ
	ShowWindow();

	return ret;
}


//////////////////////////////////////////////////////////////////
// 
// GetVideoFormatSize()
// 
// ɹ:
//     õƵʽߴ
//
// :
//     
//
// ز:
//	   Ƶʽߴ
//
//////////////////////////////////////////////////////////////////

//õƵʽߴ
DWORD CCapture::GetVideoFormatSize()
{
	return capGetVideoFormatSize(m_hCapWnd);
}


//////////////////////////////////////////////////////////////////
// 
// GetVideoFormat(BITMAPINFO * psVideoFormat)
// 
// ɹ:
//     õƵʽϢ
//
// :
//     Ƶʽṹ(BITMAPINFO) ָ
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//õƵʽϢ
DWORD CCapture::GetVideoFormat(BITMAPINFO * psVideoFormat)
{
	if(psVideoFormat == NULL)
		return false;

	//õߴ
	DWORD dwSize = capGetVideoFormatSize(m_hCapWnd);
	
	//õʽ
	DWORD ret = capGetVideoFormat(m_hCapWnd, psVideoFormat, dwSize); 

#ifdef _DEBUG

	if (ret != 0)
	{
		//
		TRACE("The width of the bitmap ( in pixels ) is %d.\n", psVideoFormat->bmiHeader.biWidth);
		//߶
		TRACE("The height of the bitmap ( in pixels ) is %d.\n", psVideoFormat->bmiHeader.biHeight);
		//λƽ
		TRACE("The planes of the bitmap is %d.\n", psVideoFormat->bmiHeader.biPlanes);
		//ر
		TRACE("The number of bits per pixel is %d.\n", psVideoFormat->bmiHeader.biBitCount);
		//ѹʽ
		TRACE("The type of compression is %x , %4.4s.\n", psVideoFormat->bmiHeader.biCompression,
			(LPSTR) &(psVideoFormat->bmiHeader.biCompression)); 
		//ͼС
		TRACE("The size of the image ( in bytes ) is %d.\n", psVideoFormat->bmiHeader.biSizeImage); 
	}

#endif

	return ret;
}


//////////////////////////////////////////////////////////////////
// 
// SetVideoFormat(BITMAPINFO * psVideoFormat)
// 
// ɹ:
//     Ƶʽ
//
// :
//     Ƶʽṹ(BITMAPINFO) ָ
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶʽ
BOOL CCapture::SetVideoFormat(BITMAPINFO * psVideoFormat)
{
	if(psVideoFormat == NULL)
		return false;

	return capSetVideoFormat(m_hCapWnd,psVideoFormat,sizeof(BITMAPINFO)); 
}

//////////////////////////////////////////////////////////////////
// 
// SetVideoFormat(int width,int height,int bitcount,int compress)
// 
// ɹ:
//     Ƶʽ
//
// :
//     width ͼ
//	   height ͼ߶
//     bitcount ͼ
//     compress ͼѹʽ
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶʽ
BOOL CCapture::SetVideoFormat(int width,int height,int bitcount,int compress)
{
	DWORD dwsize = capGetVideoFormatSize(m_hCapWnd);

	BITMAPINFO * pVideoFormat = (LPBITMAPINFO) new BYTE[dwsize]; 
	
	if(GetVideoFormat(pVideoFormat) == 0)
		return FALSE; 

	pVideoFormat->bmiHeader.biWidth = width;
	pVideoFormat->bmiHeader.biHeight = height;
	if(bitcount > 0)
		pVideoFormat->bmiHeader.biBitCount = bitcount;
	if(compress != 0)
		pVideoFormat->bmiHeader.biCompression = compress;

	BOOL ret = capSetVideoFormat(m_hCapWnd,pVideoFormat,sizeof(BITMAPINFO)); 

	delete pVideoFormat;

	return ret;
}


//////////////////////////////////////////////////////////////////
// 
// EnableOverlay()
// 
// ɹ:
//     ʹøǷʽ
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ʹøǷʽ
BOOL CCapture::EnableOverlay()
{
	CAPDRIVERCAPS CapDrvCaps; 

	if ( GetDrvCap(&CapDrvCaps) == FALSE)
		return FALSE; 

	//Ƿ֧
	if ( CapDrvCaps.fHasOverlay == FALSE)
		return FALSE;
	
	if(capOverlay(m_hCapWnd, TRUE))
		m_bOverLay = true;

	return true;
}


//////////////////////////////////////////////////////////////////
// 
// DisableOverlay()
// 
// ɹ:
//     رոǷʽ
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//رոǷʽ
BOOL CCapture::DisableOverlay()
{
	CAPDRIVERCAPS CapDrvCaps; 

	if ( GetDrvCap(&CapDrvCaps) == FALSE)
		return FALSE; 

	//Ƿ֧
	if ( CapDrvCaps.fHasOverlay == FALSE)
		return FALSE;
	
	return capOverlay(m_hCapWnd, FALSE);
}


//////////////////////////////////////////////////////////////////
// 
// SetCapFileName(CString aviname)
// 
// ɹ:
//     ò׽Aviļ
//
// :
//     ׽Aviļ aviname
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ò׽Aviļ
BOOL CCapture::SetCapFileName(CString aviname)
{
	if (aviname.IsEmpty())
		return false;

	return capFileSetCaptureFile( m_hCapWnd , aviname.GetBuffer(MAX_PATH));
}


//////////////////////////////////////////////////////////////////
// 
// PreFileAlloc(DWORD size)
// 
// ɹ:
//     Ԥļռ
//
// :
//     ļռ size
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ԥļռ
BOOL CCapture::PreFileAlloc(DWORD size)
{
	return capFileAlloc( m_hCapWnd , size);  
}


//////////////////////////////////////////////////////////////////
// 
// SetAudioFormat(WAVEFORMATEX * pwfex)
// 
// ɹ:
//     Ƶʽ
//
// :
//     Ƶʽṹָ pwfex
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶʽ
BOOL CCapture::SetAudioFormat(WAVEFORMATEX * pwfex)
{
	if(pwfex == NULL)
		return false;

	return capSetAudioFormat(m_hCapWnd, pwfex, sizeof(WAVEFORMATEX)); 
}


//////////////////////////////////////////////////////////////////
// 
// SetAudioFormat(WAVEFORMATEX * pwfex)
// 
// ɹ:
//     õƵʽ
//
// :
//     Ƶʽṹָ pwfex
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//õƵʽ
DWORD CCapture::GetAudioFormat(WAVEFORMATEX * pwfex)
{
	if(pwfex == NULL)
		return false;

	//õƵʽߴ
	DWORD dwSize = capGetVideoFormatSize(m_hCapWnd);
	
	DWORD ret;
	//õƵʽ
	ret = capGetAudioFormat(m_hCapWnd, pwfex, dwSize);

#ifdef _DEBUG
	if (pwfex != NULL)
	{
		//Ƶʽ
		TRACE("Waveform-audio format type is %x\n",pwfex->wFormatTag);
		
		//
		if( pwfex->nChannels == 1)
			TRACE("The waveform-audio is monaural data .\n");
		else
			TRACE("The waveform-audio is stereo data .\n");

		//
		TRACE("Sample rate is %u samples per second (hertz).\n" , pwfex->nSamplesPerSec);

		//ݴ
		TRACE("Required average data-transfer rate is %u bytes per second.\n" , pwfex->nAvgBytesPerSec);

		//
		TRACE("Block alignment is %u bytes.\n" , pwfex->nBlockAlign);

		//
		TRACE("The wFormatTag format type is %u bits per sample.\n" , pwfex->wBitsPerSample);

		//ϢС
		TRACE("Extra format information appended to the end of the WAVEFORMATEX structure size is %u bytes.\n" , pwfex->cbSize);
	}
		
#endif

	return ret;
}


//////////////////////////////////////////////////////////////////
// 
// GetAudioFormatSize()
// 
// ɹ:
//     õƵʽߴ
//
// :
//     
//
// ز:
//	   Ƶʽߴ
//
//////////////////////////////////////////////////////////////////

//õƵʽߴ
DWORD CCapture::GetAudioFormatSize()
{
	return capGetAudioFormatSize(m_hCapWnd);
}


//////////////////////////////////////////////////////////////////
// 
// GetCapSetup(CAPTUREPARMS * pparm)
// 
// ɹ:
//     õ׽
//
// :
//     ׽ṹָ pparm
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//õ׽
BOOL CCapture::GetCapSetup(CAPTUREPARMS * pparm)
{
	if(pparm == NULL)
		return false;

	BOOL ret;

	if(pparm == NULL)
		return false;

	ret = capCaptureGetSetup(m_hCapWnd, pparm, sizeof(CAPTUREPARMS));

#ifdef _DEBUG

	//Ҫ֡
	TRACE("Requested frame rate is %u microseconds ( %u fps )\n" ,
		pparm->dwRequestMicroSecPerFrame , 
		(DWORD) (1.0e6 / pparm->dwRequestMicroSecPerFrame));

	//ǷöԻʾ׽ʼ
	if ( pparm->fMakeUserHitOKToCapture == TRUE)
		TRACE("AVICap will display a dialog box prompting the user to initiate capture.\n");
	else
		TRACE("AVICap will not display a dialog box prompting the user to initiate capture.\n");

	//׽֡
	TRACE("During capture , maximum allowable percentage of dropped frames is %u . ( Values range from 0 to 100 .)\n",pparm->wPercentDropForError);

	//Ƿݳ
	if( pparm->fYield == TRUE)
		TRACE("The capture window is spawning a separate background thread to perform step and streaming capture.\n");
	else
		TRACE("The capture window is not spawning a separate background thread to perform step and streaming capture.\n");

	//aviļ
	TRACE("Maximum number of index entries in an AVI file is %u .(Values range from 1800 to 324,000.)\n",pparm->dwIndexSize); 

	//aviļ߼С
	TRACE("An AVI file's logical block size is %u bytes.\n",pparm->wChunkGranularity);
	
	//Ƶ
	TRACE("Maximum number of video buffers to allocate is %u.\n",pparm->wNumVideoRequested);

	//Ƿ׽
	if( pparm->fCaptureAudio == TRUE)
		TRACE("Audio is captured during streaming capture.\n");
	else
		TRACE("Audio is not captured during streaming capture.\n");

	//Ƶ
	TRACE("Maximum number of audio buffers to allocate is %u.\n",pparm->wNumAudioRequested);

	//ֹͣ׽
	TRACE("The virtual keycode used to terminate streaming capture is %x.\n",pparm->vKeyAbort);
	
	//Ƿֹͣ׽
	if (pparm->fAbortLeftMouse == TRUE)
		TRACE("The streaming capture would stop if the left mouse button is pressed.\n");
	else
		TRACE("The streaming capture would not stop if the left mouse button is pressed.\n");
 
	//ǷҼֹͣ׽
	if (pparm->fAbortRightMouse == TRUE)
		TRACE("The streaming capture would stop if the right mouse button is pressed.\n");
	else
		TRACE("The streaming capture would not stop if the right mouse button is pressed.\n");
 
	//Ƿò׽ʱ
	if (pparm->fLimitEnabled == TRUE)
		TRACE("Streaming capture would stops automaticly in %u seconds .\n",pparm->wTimeLimit);
	else
		TRACE("Streaming capture would not stops automaticly.\n");

	//ǷMCIƵԴ
	if (pparm->fMCIControl == FALSE)
		TRACE("AVICap does not control an MCI-compatible video source during streaming capture.\n"); 
	else
	{
		TRACE("AVICap controls an MCI-compatible video source during streaming capture.\n"); 
		
		//Ƿʹòʽ
		if (pparm->fStepMCIDevice == TRUE)
			TRACE("Step capture is using an MCI device as a video source is enabled. If it is FALSE, real-time capture using an MCI device is enabled.\n");  
		else
			TRACE("Step capture is not using an MCI device as a video source is enabled. If it is FALSE, real-time capture using an MCI device is enabled.\n");  
		
		//ʼ׽ʱ
		TRACE("Starting position is %u milliseconds , using the MCI device for the capture sequence.\n",pparm->dwMCIStartTime); 

		//׽ʱ
		TRACE("Stopping position is %u milliseconds , using the MCI device for the capture sequence.\n",pparm->dwMCIStopTime); 
	}

	//Ƿʹ˫Ȳ׽
	if (pparm->fStepCaptureAt2x == TRUE)
		TRACE("Double-resolution step capture is using . ( captures at twice the specified resolution. The resolution for the height and width is doubled.)");
	else
		TRACE("Not using double-resolution step capture .\n");

	//ƽ֮
	TRACE("A frame is sampled %u times  when creating a frame based on the average sample.\n",pparm->wStepCaptureAverageFrames); 

	//ƵС
	TRACE("Audio buffer size is %u.\n",pparm->dwAudioBufferSize); 

	//ǷƵͬ
	TRACE("Indicates whether the audio stream controls the clock when writing an AVI file. \n", pparm->AVStreamMaster);

#endif

	return ret;
}


//////////////////////////////////////////////////////////////////
// 
// SetCapSetup(CAPTUREPARMS * pparm)
// 
// ɹ:
//     ò׽
//
// :
//     ׽ṹָ pparm
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ò׽
BOOL CCapture::SetCapSetup(CAPTUREPARMS * pparm)
{
	if(pparm == NULL)
		return false;

	return capCaptureSetSetup(m_hCapWnd, pparm, sizeof (CAPTUREPARMS)); 
}


//////////////////////////////////////////////////////////////////
// 
// SetCapRate(int rate)
// 
// ɹ:
//     ò׽֡
//
// :
//     ׽֡ rate
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ò׽֡
BOOL CCapture::SetCapRate(int rate)
{
	CAPTUREPARMS parm;
	if (GetCapSetup(&parm) == FALSE) return FALSE;
	//΢һ֡
	parm.dwRequestMicroSecPerFrame = (DWORD) (1.0e6 / rate);
	return SetCapSetup(&parm);
}


//////////////////////////////////////////////////////////////////
// 
// GetCapRate()
// 
// ɹ:
//     õ׽֡
//
// :
//     
//
// ز:
//	   ׽֡
//
//////////////////////////////////////////////////////////////////

//õ׽֡
int CCapture::GetCapRate()
{
	CAPTUREPARMS parm;
	if (GetCapSetup(&parm) == FALSE) return -1;
	return (DWORD) (1.0e6 / parm.dwRequestMicroSecPerFrame);
}


//////////////////////////////////////////////////////////////////
// 
// SetYield(BOOL flag)
// 
// ɹ:
//     ݳ־
//
// :
//     Ƿʹ flag
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ݳ־
BOOL CCapture::SetYield(BOOL flag)
{
	CAPTUREPARMS parm;
	GetCapSetup(&parm);
	parm.fYield = flag;
	return SetCapSetup(&parm);
}


//////////////////////////////////////////////////////////////////
// 
// GetYield()
// 
// ɹ:
//     õݳ־
//
// :
//     
//
// ز:
//	   Ƿʹ
//
//////////////////////////////////////////////////////////////////

//õݳ־
BOOL CCapture::GetYield()
{
	CAPTUREPARMS parm;
	GetCapSetup(&parm);
	return parm.fYield;
}


//////////////////////////////////////////////////////////////////
// 
// SetCapAudio(BOOL flag)
// 
// ɹ:
//     Ƶ־
//
// :
//     Ƿʹ flag
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶ־
BOOL CCapture::SetCapAudio(BOOL flag)
{
	CAPTUREPARMS parm;
	GetCapSetup(&parm);
	parm.fCaptureAudio = flag;
	return SetCapSetup(&parm);
}


//////////////////////////////////////////////////////////////////
// 
// GetCapAudio()
// 
// ɹ:
//     õƵ־
//
// :
//     
//
// ز:
//	   Ƿʹ
//
//////////////////////////////////////////////////////////////////

//õƵ־
BOOL CCapture::GetCapAudio()
{
	CAPTUREPARMS parm;
	GetCapSetup(&parm);
	return parm.fCaptureAudio;
}


//////////////////////////////////////////////////////////////////
// 
// SetCapTime(int time)
// 
// ɹ:
//     ò׽ʱ
//
// :
//     ׽ʱ time
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ò׽ʱ
BOOL CCapture::SetCapTime(int time)
{
	CAPTUREPARMS parm;
	GetCapSetup(&parm);
	parm.fLimitEnabled =TRUE;
	parm.wTimeLimit = time;
	return SetCapSetup(&parm);
}


//////////////////////////////////////////////////////////////////
// 
// GetCapTime()
// 
// ɹ:
//     õ׽ʱ
//
// :
//     
//
// ز:
//	   ׽ʱ time
//
//////////////////////////////////////////////////////////////////

//õ׽ʱ
int CCapture::GetCapTime()
{
	CAPTUREPARMS parm;
	GetCapSetup(&parm);
	if (parm.fLimitEnabled == FALSE)
		return -1;
	return parm.wTimeLimit;
}


//////////////////////////////////////////////////////////////////
// 
// CaptureToFile()
// 
// ɹ:
//     ׽Aviļ
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//׽Aviļ
BOOL CCapture::CaptureToFile()
{
	return capCaptureSequence(m_hCapWnd); 
}

//void CCapture::SetDataFileName(CString name)
//{
//	m_fileCapDataName = name;
//}

//CString & CCapture::GetDataFileName()
//{
//	return m_fileCapDataName;
//	return NULL;
//}


//////////////////////////////////////////////////////////////////
// 
// SetVideoCallback(LPVOID fpvideocallback)
// 
// ɹ:
//     Ƶص
//
// :
//     ص fpvideocallback
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶص
BOOL CCapture::SetVideoCallback(LPVOID fpvideocallback)
{
	return capSetCallbackOnVideoStream(m_hCapWnd, fpvideocallback);
}


//////////////////////////////////////////////////////////////////
// 
// CaptureToData()
// 
// ɹ:
//     ׽ԴƵ
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//׽ԴƵ
BOOL CCapture::CaptureToData()
{
	return capCaptureSequenceNoFile(m_hCapWnd);
}

LONG Write(CFile * pfile,LPVOID pdata,int count)
{
	return 1L;
}

LONG CALLBACK CCapture::CallbackWriteToFile(HWND hWnd,LPVIDEOHDR lpVHdr)
{
	if( (lpVHdr->dwFlags && VHDR_DONE) == 0 ) return 0L;
	if( (lpVHdr->dwFlags && VHDR_PREPARED) == 0 ) return 0L;
	return 1L;
}

/*
typedef struct videohdr_tag {
    LPBYTE      lpData;                 // pointer to locked data buffer 
    DWORD       dwBufferLength;         // Length of data buffer 
    DWORD       dwBytesUsed;            // Bytes actually used 
    DWORD       dwTimeCaptured;         // Milliseconds from start of stream 
    DWORD       dwUser;                 // for client's use 
    DWORD       dwFlags;                // assorted flags (see defines) 
    DWORD       dwReserved[4];          // reserved for driver 
} VIDEOHDR, NEAR *PVIDEOHDR, FAR * LPVIDEOHDR;

// dwFlags field of VIDEOHDR 
#define VHDR_DONE       0x00000001  // Done bit 
#define VHDR_PREPARED   0x00000002  // Set if this header has been prepared 
#define VHDR_INQUEUE    0x00000004  // Reserved for driver 
#define VHDR_KEYFRAME   0x00000008  // Key Frame 
*/


//////////////////////////////////////////////////////////////////
// 
// SetInfoChunk(CAPINFOCHUNK * pcic)
// 
// ɹ:
//     Ϣ
//
// :
//     Ϣṹָ pcic
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ϣ
BOOL CCapture::SetInfoChunk(CAPINFOCHUNK * pcic)
{
	return capFileSetInfoChunk (m_hCapWnd, pcic); 
}


//////////////////////////////////////////////////////////////////
// 
// CallbackStatus(HWND hWnd, int nID,LPSTR lpStatusText)
// 
// ɹ:
//     ״̬ص
//
// :
//     hWnd ״̬Ϣ
//     nID ״̬Ϣ
//     lpStatusText ״̬Ϣı
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//״̬ص
LRESULT CALLBACK CCapture::CallbackStatus(HWND hWnd, int nID,LPSTR lpStatusText)
{
    HWND hwnd = m_pStaticCap->m_hCapWnd;
	if (nID == 0) 
	{
		// Clear old status messages. 
        ::SetWindowText(hwnd,AfxGetAppName()); 
        return (LRESULT) TRUE;
	} 

	static DWORD timeStart,timeEnd;
    if (nID == IDS_CAP_BEGIN) 
	{
		timeStart = timeEnd = 0;
	}
	if ((timeStart == 0) && (nID == 411))
	{
		timeStart = timeGetTime();	
	}
	if (nID == IDS_CAP_STAT_CAP_FINI)
	{
		timeEnd = timeGetTime();
	}

	// Show the status ID and status text... 
	char Buffer[255];
	if (nID == IDS_CAP_END)
		wsprintf(Buffer,"Ѳ%d.%s : Status # %u",
			(timeEnd - timeStart)/1000 , lpStatusText, nID);  
	else
		wsprintf(Buffer, "%s : Status # %d", lpStatusText, nID);  
    ::SetWindowText(hwnd,Buffer);     
	return (LRESULT) TRUE; 
} 


//////////////////////////////////////////////////////////////////
// 
// SetStatusCallback(LPVOID fpstatuscallback)
// 
// ɹ:
//     Ƶ״̬ص
//
// :
//     ״̬ص fpstatuscallback
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶ״̬ص
BOOL CCapture::SetStatusCallback(LPVOID fpstatuscallback)
{
	m_pStaticCap = this;
	return capSetCallbackOnStatus(m_hCapWnd, fpstatuscallback);
}


//////////////////////////////////////////////////////////////////
// 
// CallbackError(HWND hWnd, int nErrID,LPSTR lpErrorText)
// 
// ɹ:
//     Ƶص
//
// :
//     hWnd ܴϢ
//     nErrID Ϣ
//     lpErrorText Ϣı
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶص
LRESULT CALLBACK CCapture::CallbackError(HWND hWnd, int nErrID,LPSTR lpErrorText)
{
    if (nErrID == 0) // Starting a new major function. 
        return TRUE; // Clear out old errors.  
    
	// Show the error identifier and text. 
	char Buffer[255];
    wsprintf(Buffer, "# %d : %s", nErrID, lpErrorText);  
    AfxMessageBox(Buffer, MB_OK | MB_ICONEXCLAMATION);      

	return (LRESULT) TRUE; 
}


//////////////////////////////////////////////////////////////////
// 
// SetErrorCallback(void * fperrorcallback)
// 
// ɹ:
//     Ƶص
//
// :
//     Ƶص fperrorcallback
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶص
BOOL CCapture::SetErrorCallback(void * fperrorcallback)
{
	m_pStaticCap = this;
	return capSetCallbackOnError(m_hCapWnd, fperrorcallback);
}


//////////////////////////////////////////////////////////////////
// 
// CallbackControl(HWND hWnd, int nState)
// 
// ɹ:
//     Ƶƻص
//
// :
//     hWnd ܿϢ
//     nState Ϣ
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶƻص
LRESULT CALLBACK CCapture::CallbackControl(HWND hWnd, int nState)
{
#ifdef _DEBUG
	if ( nState == CONTROLCALLBACK_PREROLL)
		TRACE("ȴʼ׽.Waiting to start capture.\n");
	if ( nState == CONTROLCALLBACK_CAPTURING)
		TRACE("ڲ׽.Now capturing.\n");
#endif

	return TRUE; //if return FALSE ,then Abort or End
}


//////////////////////////////////////////////////////////////////
// 
// SetControlCallback(void * fpcontrolcallback)
// 
// ɹ:
//     Ƶƻص
//
// :
//     ƻص fpcontrolcallback
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶƻص
BOOL CCapture::SetControlCallback(void * fpcontrolcallback)
{
	m_pStaticCap = this;
	return capSetCallbackOnCapControl(m_hCapWnd, fpcontrolcallback);
}


//////////////////////////////////////////////////////////////////
// 
// CallbackYield(HWND hWnd)
// 
// ɹ:
//     Ƶݳص
//
// :
//     ݳ hWnd
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//Ƶݳص
LRESULT CCapture::CallbackYield(HWND hWnd)
{
	return TRUE ; 
	//return FALSE;// if streaming capture or a single-frame capture session is in progress. 
}


//////////////////////////////////////////////////////////////////
// 
// SetYieldCallback(void * fpyieldcallback)
// 
// ɹ:
//     ݳص
//
// :
//     ݳص fpyieldcallback
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ݳص
BOOL CCapture::SetYieldCallback(void * fpyieldcallback)
{
	m_pStaticCap = this;
	return capSetCallbackOnYield(m_hCapWnd, fpyieldcallback);
}


//////////////////////////////////////////////////////////////////
// 
// ShowWindow()
// 
// ɹ:
//     ʾ׽
//
// :
//     
//
// ز:
//	   Ƿʾ
//
//////////////////////////////////////////////////////////////////

//ʾ׽
BOOL CCapture::ShowWindow()
{
	bool ret = false;

	m_nWindowHided --;//һ

	if(m_nWindowHided <= 0)
	{
		//Ϊʱ,ʾ
		::ShowWindow(m_hCapWnd, SW_SHOW);

		if(m_bOverLay)
		{
			EnableOverlay();
		}

		m_nWindowHided = 0;
		ret = true;
	}	

	return ret;
}


//////////////////////////////////////////////////////////////////
// 
// ShowWindow()
// 
// ɹ:
//     ش
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ش
BOOL CCapture::HideWindow()
{
	bool ret = false;
	
	if(m_nWindowHided == 0)
	{
		if(m_bOverLay)
		{
			DisableOverlay();
		}

		::ShowWindow(m_hCapWnd, SW_HIDE);
		ret = true;
	}

	m_nWindowHided ++;//һ

	return ret;					 
}


//////////////////////////////////////////////////////////////////
// 
// CaptureFrame(CString strDibName)
// 
// ɹ:
//     ׽ĵ֡ͼ
//
// :
//     ֡ͼ strDibName
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//׽ĵ֡ͼ
BOOL CCapture::CaptureFrame(CString strDibName)
{
	//
	if(capCaptureSingleFrameOpen(m_hCapWnd))
	{
		//ɹ׽
		if(capCaptureSingleFrame(m_hCapWnd))
		{
			//׽ɹر
			if(capCaptureSingleFrameClose(m_hCapWnd))
			{
				//رճɹ򱣴
				return capFileSaveDIB(m_hCapWnd, strDibName.GetBuffer(MAX_PATH));
			}
		}
	}
	return false;
}


//////////////////////////////////////////////////////////////////
// 
// CaptureStop()
// 
// ɹ:
//     ׽ֹͣ
//
// :
//     
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//׽ֹͣ
BOOL CCapture::CaptureStop()
{
	return capCaptureStop(m_hCapWnd);
}


//////////////////////////////////////////////////////////////////
// 
// Quit()
// 
// ɹ:
//     ˳׽
//
// :
//     
//
// ز:
//	   
//
//////////////////////////////////////////////////////////////////

//˳׽
void CCapture::Quit()
{
	if(m_hCapWnd != NULL)
	{
		DisconnectDriver();
		::SendMessage(m_hCapWnd, WM_CLOSE, NULL, NULL);
		::DestroyWindow(m_hCapWnd);
		m_hCapWnd = NULL;
		m_bDrvUsed = false;
	}
}


//////////////////////////////////////////////////////////////////
// 
// InitDisplay()
// 
// ɹ:
//     ʼʾЧʹøǣʹԤ
//
// :
//     
//
// ز:
//	   
//
//////////////////////////////////////////////////////////////////

//ʼʾЧʹøǣʹԤ
void CCapture::InitDisplay()
{
	if(!EnableOverlay())
		OpenPreview();
}


//////////////////////////////////////////////////////////////////
// 
// õͼĴС
// 
// ɹ:
//     õͼĴС
//
// :
//     
//
// ز:
//	   ͼĴС
//
//////////////////////////////////////////////////////////////////

//õͼĴС
CSize CCapture::GetImageSize()
{
	CAPSTATUS Status;
	GetCapStatus(&Status);
	
	CSize Size(Status.uiImageWidth, Status.uiImageHeight);
	return Size;
}


//////////////////////////////////////////////////////////////////
// 
// õͼĴС
// 
// ɹ:
//     ôλ
//
// :
//     hWndInsertAfter ǰ򴰿
//     X λx
//     Y λx
//     cx ڴСcx
//     cy ڴСcy
//     uFlags ־
//
// ز:
//	   Ƿɹ
//
//////////////////////////////////////////////////////////////////

//ôλ
BOOL CCapture::SetWindowPos(HWND hWndInsertAfter, int X, int Y, int cx, int cy, UINT uFlags)
{
	return ::SetWindowPos(m_hCapWnd, hWndInsertAfter, X, Y, cx, cy, uFlags);
}
